import 'chai';
declare global {
    export namespace Chai {
        interface Assertion {
            html(expectedText: string | undefined, options: any): void;
            render(expectedText: string | undefined, options: any): void;
        }
    }
}
/**
 * @param { {window: Window } } [dom] - _optional_ - An object that will have a `window` property
 *   set during test execution. If not provided, the global `window` will be used.
 * @param {Assertion} [chai.Assertion] - _optional_ - Chai's Assertion class. If provided, the
 *   chainable expect methods `#html(expected)` and `#render(expected)` will be added to Chai.
 */
export declare function assertions(dom: any, Assertion: any): {
    removeComments: (node: any) => any;
    getHtml: (node: any, parentTag: any) => any;
};
